
#ifndef _FILE_H_
  #define _FILE_H_

  #ifdef __cplusplus
  extern "C" {
  #endif

  int F_write (const char *str, void *buf, unsigned size);
  int F_append (const char *str, void *buf, unsigned size);
  int F_read (const char *str, void *buf, unsigned size, unsigned position); // = 0
  void *F_load (const char *str);
  int F_exist (const char *str);
  long F_length (const char *str);

  // "easy" and low level find routines
  char *F_findNext (const char *wildname);
  void F_findReset (void);

  typedef struct
  {
    char **names;
    int cur;
    int max;
  } TF_list;

  TF_list *F_listNew (const char *wildName);
  void F_listDelete (TF_list *list);

  char *F_listNext (TF_list *list);
  char *F_listPrev (TF_list *list);
  void F_getExecPath (char *fullPath, const char *fileName);
  void F_getFullPath (char *fullPath, const char *fileName);

  #ifdef __cplusplus
  }
  #endif

#endif
