
#ifndef _IPX_SPX_H
  #define _IPX_SPX_H

  #ifdef __cplusplus
  extern "C" {
  #endif

  typedef unsigned char TNetAddr [4];
  typedef unsigned char TNodeAddr [6];

  typedef struct
  {
    TNetAddr       Network;
    TNodeAddr      Node;
    unsigned short Socket;
  } TIPXAddress;

  typedef struct
  {
    short        CheckSum;
    short        Length;
    char         TransportControl;
    char         PacketType;
    TIPXAddress   Dst;
    TIPXAddress   Src;
  } TIPXHeader;

  /*
  typedef struct SPXHeader
  {
    WORD         Checksum;
    WORD         Length;
    BYTE         TransportControl;
    BYTE         PacketType;
    IPXAddress   Destination;
    IPXAddress   Source;
    BYTE         ConnectionControl;
    BYTE         DataStreamType;
    WORD         SourceConnectionID;
    WORD         DestinationConnectionID;
    WORD         SequenceNumber;
    WORD         AcknowledgeNumber;
    WORD         AllocationNumber;
  } SPXHeader;

  typedef struct Connection_Info
  {
    BYTE         ConnectionState;
    BYTE         ConnectionFlags;
    WORD         SourceConnectionID;
    WORD         DestinationConnectionID;
    WORD         SequnceNumber;
    WORD         AcknowledgeNumber;
    WORD         AllocationNumber;
    WORD         RemoteAcknowLedgeNumber;
    WORD         RemoteAllocationNumber;
    WORD         ConnectionSocket;
    BYTE         ImmediateAddress [6];
    IPXAddress   Destination;
    WORD         RetransmisionCount;
    WORD         EstimatedRoundTripDelay;
    WORD         RetransmittedPackets;
    WORD         SuppressedPackets;
  } Connection_Info;

  typedef struct ECBFragment
  {
    short        Off;
    short        Seg;
    short        Size;
  } ECBFragment;
  */

  typedef struct
  {
    unsigned short        LinkAddressOff;
    unsigned short        LinkAddressSeg;
    unsigned short        ESRAddressOff;
    unsigned short        ESRAddressSeg;
    char         InUseFlag;
    char         CompletitionFlag;
    unsigned short        SocketNumber;
    char         IPXWorkspace [4];
    char         DriverWorkspace [12];
    TNodeAddr    ImmediateAddress;
    unsigned short FragCount;
    unsigned short FragOff;
    unsigned short FragSeg;
    unsigned short FragSize;
  } TECBHeader;

  extern int IPX_Initialize (void);
  extern void IPX_done (void);
  extern int IPX_OpenSocket (int SocketNumber);
  extern void IPX_CloseSocket (int SocketNumber);
  extern int IPX_GetLocalTarget (TIPXAddress *addr, TNodeAddr *ImmediateAddress, short *TransportTime);
  extern int IPX_SendPacket (TECBHeader *ECBBlock);
  extern void IPX_ReceivePacket (TECBHeader *ECBBlock);
  extern void IPX_ScheduleEvent (short DelayTime, TECBHeader *ECBBlock);
  extern int IPX_CancelEvent (TECBHeader *ECBBlock);
  extern void IPX_ScheduleSpecialEvent (short DelayTime, TECBHeader *ECBBlock);
  extern unsigned short IPX_GetIntervalMarker (void);
  extern void IPX_GetLocalAddress (TIPXAddress *NetworkAddress);
  extern void IPX_DisableCPUControl (void);
  extern void IPX_CloseConnection (TIPXAddress NetworkAddress);

  #ifdef __cplusplus
  }
  #endif

#endif
